/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: AlsaMidiDriver.h,v 1.6 2003/01/27 12:50:40 comix Exp $
 *
 */

#include "config.h"

// check if ALSA_SEQ support is enabled
#ifdef USE_ALSA_SEQ


 
#ifndef ALSA_MIDI_DRIVER_H
#define ALSA_MIDI_DRIVER_H

#include <alsa/asoundlib.h>
#include "Object.h"
#include "Hydrogen.h"
#include "Song.h"



/**
 * AlsaMidiDriver
 * Based on Dr Matthias Nagorni alsa sequencer example
 */
class AlsaMidiDriver : public Object {
	private:
		bool active;
		
	public:
		virtual string getClassName() {	return "AlsaMidiDriver";	}

		AlsaMidiDriver();
		~AlsaMidiDriver();

		void open();
		void close();
		void midi_action(snd_seq_t *seq_handle);
		void setActive(bool isActive) {	this->active = isActive;	}
};


#endif // USE_ALSA_SEQ

#endif 
