/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: JackDriver.h,v 1.14 2003/02/13 23:06:28 comix Exp $
 *
 */

#include "config.h"

// check if jack support is enabled
#ifdef JACK_SUPPORT


#ifndef JACK_DRIVER_H
#define JACK_DRIVER_H

#include <pthread.h>
#include <jack/jack.h>

#include "GenericDriver.h"
using std::cout;
using std::endl;

//----------------------------------------------------------------------------
/**
 * Jack (Jack Audio Connection Kit) server driver
 */
class JackDriver : public GenericDriver {

	private:
		jack_client_t *client;
		jack_port_t *output_port_1;
		jack_port_t *output_port_2;
		JackProcessCallback processCallback;


	public:
		virtual string getClassName() {	return "JackDriver";	}

		/** Constructor */
		JackDriver(JackProcessCallback processCallback);

		/** Destructor */
		~JackDriver();

		int connect();

		void disconnect();

		void write(float* buffer_L, float* buffer_R, unsigned int bufferSize);

		void setBufferSize(uint bufferSize);
		uint getBufferSize();

		uint getSampleRate();
};


#endif // JACK_SUPPORT

#endif

