/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Object.h,v 1.4 2002/12/28 22:27:26 comix Exp $
 *
 */

#ifndef H2_OBJECT_H
#define H2_OBJECT_H


#include <iostream>
#include <string>
using std::string;


class Object;

//----------------------------------------------------------------------------
/**
 * Class for writing logs to the console
 */
class Logger {
	private:

	public:
		/** Constructor */
		Logger();

		/** Destructor */
		~Logger();

		/** Simple log */
		void log(string logMsg);

		/** Information Log*/
		void info(Object *obj, string logMsg);

		/** Error Log*/
		void error(Object *obj, string errorMsg);

};


//----------------------------------------------------------------------------
/**
 * Base class.
 */
class Object{
	private:
		static uint nObjects;
		Logger logger;
	public:
		/** Constructor */
		Object();

		/** Destructor */
		virtual ~Object();

		/** Return the class name */
		virtual string getClassName() = 0;

		static uint getNObjects();


		void infoLog(string msg);
		void errorLog(string msg);
};





#endif
