/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: OssDriver.h,v 1.11 2003/02/13 23:06:29 comix Exp $
 *
 */

#ifndef OSS_AUDIO_DRIVER_H
#define OSS_AUDIO_DRIVER_H

#include <sys/soundcard.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <iostream>
#include <unistd.h>

using std::cout;
using std::endl;

#include "GenericDriver.h"
#include "PreferencesMng.h"

#define AUDIO_DEVICE "/dev/dsp"

typedef int  (*audioProcessCallback)(unsigned long, void *);

//----------------------------------------------------------------------------
/**
 * OSS Audio Driver
 */
class OssDriver : public GenericDriver {
	private:
		/** file descriptor, for writing to /dev/dsp */
		int fd;

		short* audioBuffer;

		audioProcessCallback processCallback;
		int log2(int n);
		
	public:
		virtual string getClassName() {	return "OssDriver";	}

		/** Constructor */
		OssDriver(audioProcessCallback processCallback);

		/** Destructor */
		~OssDriver();

		int connect();

		void disconnect();

		void write(float* buffer_L, float* buffer_R, unsigned int bufferSize);
		void setBufferSize(uint bufferSize);
		uint getBufferSize();
		uint getSampleRate();
};




#endif
